(function(){"use strict";try{var e=document.createElement("style");e.appendChild(document.createTextNode(".mk-input{min-height:1.4em}.mk-input span{outline:none;white-space:pre-wrap}.mk-suggestions{border:1px solid #ccc;max-height:186px;overflow-y:auto;padding-left:0;position:absolute;background:white;width:fit-content;min-width:100px;transition:1.1s ease-out;filter:blur(0);transform:scale(1);opacity:1;visibility:visible;color:#000;border-radius:4%;box-shadow:0 3px 6px -2px #0009}.mk-suggestions li{padding:.5rem}.mk-suggestions li:hover,.mk-suggestion-active{background-color:#cce9ff;color:#2589f5;cursor:pointer}")),document.head.appendChild(e)}catch(i){console.error("vite-plugin-css-injected-by-js",i)}})();
var Qe = (n, e, r) => {
  if (!e.has(n))
    throw TypeError("Cannot " + r);
};
var L = (n, e, r) => (Qe(n, e, "read from private field"), r ? r.call(n) : e.get(n)), z = (n, e, r) => {
  if (e.has(n))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(n) : e.set(n, r);
};
var ae = (n, e, r) => (Qe(n, e, "access private method"), r);
import we, { useContext as Ut, Children as Vt, isValidElement as et, useRef as G, useLayoutEffect as Yt, forwardRef as st, useEffect as Z, useMemo as K, useCallback as ue, useState as xe } from "react";
const $ = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var I = /* @__PURE__ */ ((n) => (n.LABEL = "__label__", n.VALUE = "__value__", n))(I || {});
const tt = "mk-input", rt = {
  trigger: "@",
  markup: "@[__label__](__value__)",
  data: []
}, Kt = ["onFocus", "onBlur", "onKeyDown", "onClick"], Gt = new RegExp(/^\w*/);
class Ht {
  constructor(e, r) {
    this.raw = e, this.uniRegExp = r, this.done = !1;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let e = this.uniRegExp.exec(this.raw);
    if (e === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [r, o, a] = this.extractPieces(e);
    return this.raw = a, { done: !1, value: [r, o] };
  }
  extractPieces(e) {
    const r = this.extractMark(e), o = r.input.substring(0, r.index), a = r.input.substring(r.index + r.annotation.length);
    return [o, r, a];
  }
  extractMark(e) {
    let r = e[0], o = 0, a = e[1], i = e[2];
    for (; !(a || i); )
      o++, a = e[2 * o + 1], i = e[2 * o + 2];
    let l = e.index, f = e.input;
    return { annotation: r, label: a, value: i, input: f, index: l, childIndex: o };
  }
}
class fe {
  get regExps() {
    return this.markups.map(qt);
  }
  static split(e, r) {
    const o = r.map((a) => a.markup);
    return () => new fe(o).split(e);
  }
  constructor(e) {
    this.markups = e, this.uniRegExp = new RegExp(this.regExps.map((r) => r.source).join("|"));
  }
  split(e) {
    return this.iterateMatches(e);
  }
  iterateMatches(e) {
    const r = [];
    for (let [o, a] of new Ht(e, this.uniRegExp))
      r.push(o), a !== null && r.push(zt(a, this.markups[a.childIndex]));
    return r;
  }
}
const it = Object.assign, qt = (n) => {
  const e = se(n), r = n[n.indexOf(I.LABEL) + I.LABEL.length], o = n[n.indexOf(I.VALUE) + I.VALUE.length];
  return new RegExp(
    e.replace(I.LABEL, `([^${se(r || "")}]+?)`).replace(I.VALUE, `([^${se(o || "")}]+?)`)
  );
};
function _e(n, e, r) {
  let o = n.replace(I.LABEL, e);
  return r ? o.replace(I.VALUE, r) : o;
}
function jr(n, e, ...r) {
  return r.length ? new fe(r).split(n).reduce((a, i) => a += de(i) ? e(i) : i, "") : n;
}
const se = (n) => n.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function nt(n, e) {
  let r = "";
  for (let o of n)
    r += de(o) ? _e(e[o.childIndex].markup, o.label, o.value) : o;
  return r;
}
const zt = (n, e) => n.annotation !== _e(e, n.label, n.value) ? { ...n, label: n.value, value: n.label } : n, ce = (n, e = 0) => {
  let r = 3735928559 ^ e, o = 1103547991 ^ e;
  for (let a = 0, i; a < n.length; a++)
    i = n.charCodeAt(a), r = Math.imul(r ^ i, 2654435761), o = Math.imul(o ^ i, 1597334677);
  return r = Math.imul(r ^ r >>> 16, 2246822507) ^ Math.imul(o ^ o >>> 13, 3266489909), o = Math.imul(o ^ o >>> 16, 2246822507) ^ Math.imul(r ^ r >>> 13, 3266489909), 4294967296 * (2097151 & o) + (r >>> 0);
}, de = (n) => typeof n == "object", Jt = (n) => typeof n == "function", Xt = (n) => typeof n == "string" && n.startsWith("on"), Zt = (n) => et(n) ? !0 : et(n == null ? void 0 : n[0]);
function Qt(n) {
  if (Zt(n))
    return Vt.map(n, (r) => e(r.props));
  if (n != null && n.length)
    return n.map(e);
  return [rt];
  function e(r) {
    return it({}, rt, r);
  }
}
const er = (n) => {
  const e = we.createContext(void 0);
  e.displayName = n;
  const r = a(e), o = e.Provider;
  return [r, o];
  function a(i) {
    return () => {
      const l = Ut(i);
      if (l)
        return l;
      throw new Error(`The context ${i.displayName} didn't found!`);
    };
  }
}, [k, tr] = er("MarkedInputStoreProvider");
function rr(n, e, r = !0) {
  let o;
  return () => {
    const i = r && !o;
    clearTimeout(o), o = setTimeout(a, e), i && n.apply(arguments);
  };
  function a() {
    o = void 0, r || n(arguments);
  }
}
function nr(n, e) {
  let r;
  for (let [o, a] of e.entries())
    if (a === n) {
      r = o;
      break;
    }
  return r;
}
function or(n, e, r, o) {
  return n.slice(0, r) + e + n.slice(r + o.length);
}
class O {
  static get isSelectedPosition() {
    const e = window.getSelection();
    if (!!e)
      return e.anchorOffset === e.focusOffset;
  }
  static getCurrentPosition() {
    var e, r;
    return (r = (e = window.getSelection()) == null ? void 0 : e.anchorOffset) != null ? r : 0;
  }
  static getFocusedSpan() {
    var e, r, o;
    return (o = (r = (e = window.getSelection()) == null ? void 0 : e.anchorNode) == null ? void 0 : r.textContent) != null ? o : "";
  }
  static getSelectedNode() {
    var r;
    const e = (r = window.getSelection()) == null ? void 0 : r.anchorNode;
    if (e)
      return e;
    throw new Error("Anchor node of selection is not exists!");
  }
  static getAbsolutePosition() {
    var r, o, a;
    const e = (a = (r = window.getSelection()) == null ? void 0 : (o = r.getRangeAt(0)).getBoundingClientRect) == null ? void 0 : a.call(o);
    return e ? {
      left: e.left,
      top: e.top + 20
    } : {
      left: 0,
      top: 0
    };
  }
  static setIndex(e, r) {
    const o = window.getSelection();
    if (!(o != null && o.anchorNode) || !o.rangeCount)
      return;
    const a = o.getRangeAt(0);
    a == null || a.setStart(e.firstChild || e, r), a == null || a.setEnd(e.firstChild || e, r);
  }
  static getCaretIndex(e) {
    let r = 0;
    const o = window.getSelection();
    if (!(o != null && o.rangeCount))
      return r;
    const a = o.getRangeAt(0), i = a.cloneRange();
    return i.selectNodeContents(e), i.setEnd(a.endContainer, a.endOffset), r = i.toString().length, r;
  }
  static setCaretToEnd(e) {
    if (!e)
      return;
    const r = window.getSelection();
    r == null || r.setPosition(e, 1);
  }
  static getIndex() {
    var r;
    const e = window.getSelection();
    return (r = e == null ? void 0 : e.anchorOffset) != null ? r : NaN;
  }
  static setIndex1(e) {
    const r = window.getSelection();
    if (!(r != null && r.anchorNode) || !r.rangeCount)
      return;
    const o = r.getRangeAt(0);
    o == null || o.setStart(o.startContainer.firstChild || o.startContainer, e), o == null || o.setEnd(o.startContainer.firstChild || o.startContainer, e);
  }
  setCaretRightTo(e, r) {
    const o = window.getSelection(), a = o == null ? void 0 : o.getRangeAt(0);
    a == null || a.setStart(a.endContainer, r), a == null || a.setEnd(a.endContainer, r);
  }
}
const ar = (n) => {
  const e = G(NaN);
  function r() {
    !n.current || (e.current = O.getCaretIndex(n.current));
  }
  function o() {
    !n.current || (O.setIndex(n.current, e.current), e.current = NaN);
  }
  return Yt(() => {
    Number.isNaN(e.current) || o();
  }), r;
};
var x = /* @__PURE__ */ ((n) => (n[n.Change = 0] = "Change", n[n.Delete = 1] = "Delete", n[n.CheckTrigger = 2] = "CheckTrigger", n[n.ClearTrigger = 3] = "ClearTrigger", n[n.Select = 4] = "Select", n))(x || {}), Se = { exports: {} }, J = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var ot;
function sr() {
  if (ot)
    return J;
  ot = 1;
  var n = we, e = Symbol.for("react.element"), r = Symbol.for("react.fragment"), o = Object.prototype.hasOwnProperty, a = n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, i = { key: !0, ref: !0, __self: !0, __source: !0 };
  function l(f, h, R) {
    var E, b = {}, w = null, P = null;
    R !== void 0 && (w = "" + R), h.key !== void 0 && (w = "" + h.key), h.ref !== void 0 && (P = h.ref);
    for (E in h)
      o.call(h, E) && !i.hasOwnProperty(E) && (b[E] = h[E]);
    if (f && f.defaultProps)
      for (E in h = f.defaultProps, h)
        b[E] === void 0 && (b[E] = h[E]);
    return { $$typeof: e, type: f, key: w, ref: P, props: b, _owner: a.current };
  }
  return J.Fragment = r, J.jsx = l, J.jsxs = l, J;
}
var X = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var at;
function ir() {
  return at || (at = 1, process.env.NODE_ENV !== "production" && function() {
    var n = we, e = Symbol.for("react.element"), r = Symbol.for("react.portal"), o = Symbol.for("react.fragment"), a = Symbol.for("react.strict_mode"), i = Symbol.for("react.profiler"), l = Symbol.for("react.provider"), f = Symbol.for("react.context"), h = Symbol.for("react.forward_ref"), R = Symbol.for("react.suspense"), E = Symbol.for("react.suspense_list"), b = Symbol.for("react.memo"), w = Symbol.for("react.lazy"), P = Symbol.for("react.offscreen"), F = Symbol.iterator, he = "@@iterator";
    function Q(t) {
      if (t === null || typeof t != "object")
        return null;
      var s = F && t[F] || t[he];
      return typeof s == "function" ? s : null;
    }
    var A = n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function g(t) {
      {
        for (var s = arguments.length, u = new Array(s > 1 ? s - 1 : 0), c = 1; c < s; c++)
          u[c - 1] = arguments[c];
        ct("error", t, u);
      }
    }
    function ct(t, s, u) {
      {
        var c = A.ReactDebugCurrentFrame, v = c.getStackAddendum();
        v !== "" && (s += "%s", u = u.concat([v]));
        var m = u.map(function(p) {
          return String(p);
        });
        m.unshift("Warning: " + s), Function.prototype.apply.call(console[t], console, m);
      }
    }
    var lt = !1, ft = !1, dt = !1, ht = !1, pt = !1, ke;
    ke = Symbol.for("react.module.reference");
    function vt(t) {
      return !!(typeof t == "string" || typeof t == "function" || t === o || t === i || pt || t === a || t === R || t === E || ht || t === P || lt || ft || dt || typeof t == "object" && t !== null && (t.$$typeof === w || t.$$typeof === b || t.$$typeof === l || t.$$typeof === f || t.$$typeof === h || t.$$typeof === ke || t.getModuleId !== void 0));
    }
    function gt(t, s, u) {
      var c = t.displayName;
      if (c)
        return c;
      var v = s.displayName || s.name || "";
      return v !== "" ? u + "(" + v + ")" : u;
    }
    function Oe(t) {
      return t.displayName || "Context";
    }
    function N(t) {
      if (t == null)
        return null;
      if (typeof t.tag == "number" && g("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof t == "function")
        return t.displayName || t.name || null;
      if (typeof t == "string")
        return t;
      switch (t) {
        case o:
          return "Fragment";
        case r:
          return "Portal";
        case i:
          return "Profiler";
        case a:
          return "StrictMode";
        case R:
          return "Suspense";
        case E:
          return "SuspenseList";
      }
      if (typeof t == "object")
        switch (t.$$typeof) {
          case f:
            var s = t;
            return Oe(s) + ".Consumer";
          case l:
            var u = t;
            return Oe(u._context) + ".Provider";
          case h:
            return gt(t, t.render, "ForwardRef");
          case b:
            var c = t.displayName || null;
            return c !== null ? c : N(t.type) || "Memo";
          case w: {
            var v = t, m = v._payload, p = v._init;
            try {
              return N(p(m));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var M = Object.assign, H = 0, De, Ae, Ne, je, Ie, Le, Fe;
    function Me() {
    }
    Me.__reactDisabledLog = !0;
    function Et() {
      {
        if (H === 0) {
          De = console.log, Ae = console.info, Ne = console.warn, je = console.error, Ie = console.group, Le = console.groupCollapsed, Fe = console.groupEnd;
          var t = {
            configurable: !0,
            enumerable: !0,
            value: Me,
            writable: !0
          };
          Object.defineProperties(console, {
            info: t,
            log: t,
            warn: t,
            error: t,
            group: t,
            groupCollapsed: t,
            groupEnd: t
          });
        }
        H++;
      }
    }
    function mt() {
      {
        if (H--, H === 0) {
          var t = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: M({}, t, {
              value: De
            }),
            info: M({}, t, {
              value: Ae
            }),
            warn: M({}, t, {
              value: Ne
            }),
            error: M({}, t, {
              value: je
            }),
            group: M({}, t, {
              value: Ie
            }),
            groupCollapsed: M({}, t, {
              value: Le
            }),
            groupEnd: M({}, t, {
              value: Fe
            })
          });
        }
        H < 0 && g("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var pe = A.ReactCurrentDispatcher, ve;
    function ee(t, s, u) {
      {
        if (ve === void 0)
          try {
            throw Error();
          } catch (v) {
            var c = v.stack.trim().match(/\n( *(at )?)/);
            ve = c && c[1] || "";
          }
        return `
` + ve + t;
      }
    }
    var ge = !1, te;
    {
      var Rt = typeof WeakMap == "function" ? WeakMap : Map;
      te = new Rt();
    }
    function $e(t, s) {
      if (!t || ge)
        return "";
      {
        var u = te.get(t);
        if (u !== void 0)
          return u;
      }
      var c;
      ge = !0;
      var v = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var m;
      m = pe.current, pe.current = null, Et();
      try {
        if (s) {
          var p = function() {
            throw Error();
          };
          if (Object.defineProperty(p.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(p, []);
            } catch (j) {
              c = j;
            }
            Reflect.construct(t, [], p);
          } else {
            try {
              p.call();
            } catch (j) {
              c = j;
            }
            t.call(p.prototype);
          }
        } else {
          try {
            throw Error();
          } catch (j) {
            c = j;
          }
          t();
        }
      } catch (j) {
        if (j && c && typeof j.stack == "string") {
          for (var d = j.stack.split(`
`), _ = c.stack.split(`
`), y = d.length - 1, C = _.length - 1; y >= 1 && C >= 0 && d[y] !== _[C]; )
            C--;
          for (; y >= 1 && C >= 0; y--, C--)
            if (d[y] !== _[C]) {
              if (y !== 1 || C !== 1)
                do
                  if (y--, C--, C < 0 || d[y] !== _[C]) {
                    var T = `
` + d[y].replace(" at new ", " at ");
                    return t.displayName && T.includes("<anonymous>") && (T = T.replace("<anonymous>", t.displayName)), typeof t == "function" && te.set(t, T), T;
                  }
                while (y >= 1 && C >= 0);
              break;
            }
        }
      } finally {
        ge = !1, pe.current = m, mt(), Error.prepareStackTrace = v;
      }
      var B = t ? t.displayName || t.name : "", Ze = B ? ee(B) : "";
      return typeof t == "function" && te.set(t, Ze), Ze;
    }
    function yt(t, s, u) {
      return $e(t, !1);
    }
    function Ct(t) {
      var s = t.prototype;
      return !!(s && s.isReactComponent);
    }
    function re(t, s, u) {
      if (t == null)
        return "";
      if (typeof t == "function")
        return $e(t, Ct(t));
      if (typeof t == "string")
        return ee(t);
      switch (t) {
        case R:
          return ee("Suspense");
        case E:
          return ee("SuspenseList");
      }
      if (typeof t == "object")
        switch (t.$$typeof) {
          case h:
            return yt(t.render);
          case b:
            return re(t.type, s, u);
          case w: {
            var c = t, v = c._payload, m = c._init;
            try {
              return re(m(v), s, u);
            } catch {
            }
          }
        }
      return "";
    }
    var ne = Object.prototype.hasOwnProperty, We = {}, Be = A.ReactDebugCurrentFrame;
    function oe(t) {
      if (t) {
        var s = t._owner, u = re(t.type, t._source, s ? s.type : null);
        Be.setExtraStackFrame(u);
      } else
        Be.setExtraStackFrame(null);
    }
    function bt(t, s, u, c, v) {
      {
        var m = Function.call.bind(ne);
        for (var p in t)
          if (m(t, p)) {
            var d = void 0;
            try {
              if (typeof t[p] != "function") {
                var _ = Error((c || "React class") + ": " + u + " type `" + p + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof t[p] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw _.name = "Invariant Violation", _;
              }
              d = t[p](s, p, c, u, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (y) {
              d = y;
            }
            d && !(d instanceof Error) && (oe(v), g("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", c || "React class", u, p, typeof d), oe(null)), d instanceof Error && !(d.message in We) && (We[d.message] = !0, oe(v), g("Failed %s type: %s", u, d.message), oe(null));
          }
      }
    }
    var wt = Array.isArray;
    function Ee(t) {
      return wt(t);
    }
    function xt(t) {
      {
        var s = typeof Symbol == "function" && Symbol.toStringTag, u = s && t[Symbol.toStringTag] || t.constructor.name || "Object";
        return u;
      }
    }
    function _t(t) {
      try {
        return Ue(t), !1;
      } catch {
        return !0;
      }
    }
    function Ue(t) {
      return "" + t;
    }
    function Ve(t) {
      if (_t(t))
        return g("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", xt(t)), Ue(t);
    }
    var q = A.ReactCurrentOwner, St = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, Ye, Ke, me;
    me = {};
    function Tt(t) {
      if (ne.call(t, "ref")) {
        var s = Object.getOwnPropertyDescriptor(t, "ref").get;
        if (s && s.isReactWarning)
          return !1;
      }
      return t.ref !== void 0;
    }
    function Pt(t) {
      if (ne.call(t, "key")) {
        var s = Object.getOwnPropertyDescriptor(t, "key").get;
        if (s && s.isReactWarning)
          return !1;
      }
      return t.key !== void 0;
    }
    function kt(t, s) {
      if (typeof t.ref == "string" && q.current && s && q.current.stateNode !== s) {
        var u = N(q.current.type);
        me[u] || (g('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', N(q.current.type), t.ref), me[u] = !0);
      }
    }
    function Ot(t, s) {
      {
        var u = function() {
          Ye || (Ye = !0, g("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", s));
        };
        u.isReactWarning = !0, Object.defineProperty(t, "key", {
          get: u,
          configurable: !0
        });
      }
    }
    function Dt(t, s) {
      {
        var u = function() {
          Ke || (Ke = !0, g("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", s));
        };
        u.isReactWarning = !0, Object.defineProperty(t, "ref", {
          get: u,
          configurable: !0
        });
      }
    }
    var At = function(t, s, u, c, v, m, p) {
      var d = {
        $$typeof: e,
        type: t,
        key: s,
        ref: u,
        props: p,
        _owner: m
      };
      return d._store = {}, Object.defineProperty(d._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(d, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: c
      }), Object.defineProperty(d, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: v
      }), Object.freeze && (Object.freeze(d.props), Object.freeze(d)), d;
    };
    function Nt(t, s, u, c, v) {
      {
        var m, p = {}, d = null, _ = null;
        u !== void 0 && (Ve(u), d = "" + u), Pt(s) && (Ve(s.key), d = "" + s.key), Tt(s) && (_ = s.ref, kt(s, v));
        for (m in s)
          ne.call(s, m) && !St.hasOwnProperty(m) && (p[m] = s[m]);
        if (t && t.defaultProps) {
          var y = t.defaultProps;
          for (m in y)
            p[m] === void 0 && (p[m] = y[m]);
        }
        if (d || _) {
          var C = typeof t == "function" ? t.displayName || t.name || "Unknown" : t;
          d && Ot(p, C), _ && Dt(p, C);
        }
        return At(t, d, _, v, c, q.current, p);
      }
    }
    var Re = A.ReactCurrentOwner, Ge = A.ReactDebugCurrentFrame;
    function W(t) {
      if (t) {
        var s = t._owner, u = re(t.type, t._source, s ? s.type : null);
        Ge.setExtraStackFrame(u);
      } else
        Ge.setExtraStackFrame(null);
    }
    var ye;
    ye = !1;
    function Ce(t) {
      return typeof t == "object" && t !== null && t.$$typeof === e;
    }
    function He() {
      {
        if (Re.current) {
          var t = N(Re.current.type);
          if (t)
            return `

Check the render method of \`` + t + "`.";
        }
        return "";
      }
    }
    function jt(t) {
      {
        if (t !== void 0) {
          var s = t.fileName.replace(/^.*[\\\/]/, ""), u = t.lineNumber;
          return `

Check your code at ` + s + ":" + u + ".";
        }
        return "";
      }
    }
    var qe = {};
    function It(t) {
      {
        var s = He();
        if (!s) {
          var u = typeof t == "string" ? t : t.displayName || t.name;
          u && (s = `

Check the top-level render call using <` + u + ">.");
        }
        return s;
      }
    }
    function ze(t, s) {
      {
        if (!t._store || t._store.validated || t.key != null)
          return;
        t._store.validated = !0;
        var u = It(s);
        if (qe[u])
          return;
        qe[u] = !0;
        var c = "";
        t && t._owner && t._owner !== Re.current && (c = " It was passed a child from " + N(t._owner.type) + "."), W(t), g('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', u, c), W(null);
      }
    }
    function Je(t, s) {
      {
        if (typeof t != "object")
          return;
        if (Ee(t))
          for (var u = 0; u < t.length; u++) {
            var c = t[u];
            Ce(c) && ze(c, s);
          }
        else if (Ce(t))
          t._store && (t._store.validated = !0);
        else if (t) {
          var v = Q(t);
          if (typeof v == "function" && v !== t.entries)
            for (var m = v.call(t), p; !(p = m.next()).done; )
              Ce(p.value) && ze(p.value, s);
        }
      }
    }
    function Lt(t) {
      {
        var s = t.type;
        if (s == null || typeof s == "string")
          return;
        var u;
        if (typeof s == "function")
          u = s.propTypes;
        else if (typeof s == "object" && (s.$$typeof === h || s.$$typeof === b))
          u = s.propTypes;
        else
          return;
        if (u) {
          var c = N(s);
          bt(u, t.props, "prop", c, t);
        } else if (s.PropTypes !== void 0 && !ye) {
          ye = !0;
          var v = N(s);
          g("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", v || "Unknown");
        }
        typeof s.getDefaultProps == "function" && !s.getDefaultProps.isReactClassApproved && g("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function Ft(t) {
      {
        for (var s = Object.keys(t.props), u = 0; u < s.length; u++) {
          var c = s[u];
          if (c !== "children" && c !== "key") {
            W(t), g("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", c), W(null);
            break;
          }
        }
        t.ref !== null && (W(t), g("Invalid attribute `ref` supplied to `React.Fragment`."), W(null));
      }
    }
    function Xe(t, s, u, c, v, m) {
      {
        var p = vt(t);
        if (!p) {
          var d = "";
          (t === void 0 || typeof t == "object" && t !== null && Object.keys(t).length === 0) && (d += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var _ = jt(v);
          _ ? d += _ : d += He();
          var y;
          t === null ? y = "null" : Ee(t) ? y = "array" : t !== void 0 && t.$$typeof === e ? (y = "<" + (N(t.type) || "Unknown") + " />", d = " Did you accidentally export a JSX literal instead of a component?") : y = typeof t, g("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", y, d);
        }
        var C = Nt(t, s, u, v, m);
        if (C == null)
          return C;
        if (p) {
          var T = s.children;
          if (T !== void 0)
            if (c)
              if (Ee(T)) {
                for (var B = 0; B < T.length; B++)
                  Je(T[B], t);
                Object.freeze && Object.freeze(T);
              } else
                g("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              Je(T, t);
        }
        return t === o ? Ft(C) : Lt(C), C;
      }
    }
    function Mt(t, s, u) {
      return Xe(t, s, u, !0);
    }
    function $t(t, s, u) {
      return Xe(t, s, u, !1);
    }
    var Wt = $t, Bt = Mt;
    X.Fragment = o, X.jsx = Wt, X.jsxs = Bt;
  }()), X;
}
(function(n) {
  process.env.NODE_ENV === "production" ? n.exports = sr() : n.exports = ir();
})(Se);
const D = Se.exports.jsx, ut = Se.exports.jsxs, ur = st(({
  id: n,
  value: e
}, r) => {
  const {
    bus: o,
    props: {
      readOnly: a,
      spanStyle: i,
      spanClassName: l
    }
  } = k(), f = G(null);
  typeof r == "function" && r(f);
  const h = ar(f);
  return /* @__PURE__ */ D("span", {
    ref: f,
    style: i,
    className: l,
    contentEditable: !a,
    suppressContentEditableWarning: !0,
    onInput: (E) => {
      var w;
      h();
      const b = (w = E.currentTarget.textContent) != null ? w : "";
      o.send(x.Change, {
        key: n,
        value: b
      });
    },
    onPaste: cr,
    children: e
  });
});
function cr(n) {
  n.preventDefault();
  const e = n.clipboardData.getData("text");
  document.execCommand("insertText", !1, e);
}
const lr = (n) => {
  const e = G(null);
  return Z(() => {
    var r;
    if (e.current) {
      const {
        key: o,
        caret: a
      } = e.current;
      let i = (r = n.get(o)) == null ? void 0 : r.current;
      i == null || i.focus(), i && O.setIndex(i, a), e.current = null;
    }
  }), e;
};
function S(n, e, r, o) {
  const {
    bus: a
  } = o != null ? o : k();
  Z(() => a.listen(n, e), r);
}
const fr = () => {
  const n = K(() => /* @__PURE__ */ new Map(), []), e = ue((r) => (o) => n.set(r, o), []);
  return S(x.Change, () => n.clear(), []), S(x.Delete, () => n.clear(), []), {
    register: e,
    spanRefs: n
  };
}, dr = () => {
  const n = G(null);
  return S("onFocus", (e) => n.current = e.target, []), S("onBlur", (e) => n.current = null, []), n;
};
class hr {
  constructor(e, r, o, a) {
    this.focusedSpanRef = e, this.spanRefs = r, this.recoveryRef = o, this.pieces = a;
  }
  recoverLeft() {
    var a, i;
    let e = (a = this.getPreviousElement()) == null ? void 0 : a.textContent, r = (i = this.focusedSpanRef.current) == null ? void 0 : i.textContent, o = e + r;
    this.recoveryRef.current = {
      key: ce(o),
      caret: e.length
    };
  }
  recoverRight() {
    var a, i;
    let e = (a = this.getNextElement()) == null ? void 0 : a.textContent, r = (i = this.focusedSpanRef.current) == null ? void 0 : i.textContent, o = r + e;
    this.recoveryRef.current = {
      key: ce(o),
      caret: r.length
    };
  }
  getPreviousElement() {
    let e = null;
    if (!this.focusedSpanRef.current)
      return null;
    for (const [r, o] of this.spanRefs) {
      if (o.current === this.focusedSpanRef.current)
        return e;
      e = o.current;
    }
    return null;
  }
  getNextElement() {
    let e = !1;
    if (!this.focusedSpanRef.current)
      return null;
    for (const [r, o] of this.spanRefs) {
      if (e)
        return o.current;
      o.current === this.focusedSpanRef.current && (e = !0);
    }
    return null;
  }
  getPreviousMarkKey() {
    let e = null;
    const r = this.getCurrentKey();
    if (!r)
      return null;
    for (const [o] of this.pieces) {
      if (o === r)
        return e;
      e = o;
    }
    return null;
  }
  getNextMarkKey() {
    let e = !1;
    const r = this.getCurrentKey();
    if (!r)
      return null;
    for (const [o] of this.pieces) {
      if (e)
        return o;
      o === r && (e = !0);
    }
    return null;
  }
  getCurrentKey() {
    if (!this.focusedSpanRef.current)
      return null;
    for (const [e, r] of this.spanRefs)
      if (r.current === this.focusedSpanRef.current)
        return e;
    return null;
  }
}
function pr(n, e, r) {
  const {
    pieces: o,
    bus: a
  } = k();
  S("onKeyDown", (i) => {
    var Q, A;
    const l = new hr(r, n, e, o), f = i.target, h = O.getCaretIndex(f), R = h === 0, E = h === ((Q = f.textContent) == null ? void 0 : Q.length), b = {
      [$.LEFT]: R ? w : null,
      [$.RIGHT]: E ? P : null,
      [$.UP]: null,
      [$.DOWN]: null,
      [$.DELETE]: E ? he : null,
      [$.BACKSPACE]: R ? F : null
    };
    (A = b[i.key]) == null || A.call(b);
    function w() {
      const g = l.getPreviousElement();
      g == null || g.focus(), O.setCaretToEnd(g), i.preventDefault();
    }
    function P() {
      const g = l.getNextElement();
      g == null || g.focus(), i.preventDefault();
    }
    function F() {
      const g = l.getPreviousMarkKey();
      !g || (l.recoverLeft(), a.send(x.Delete, {
        key: g
      }), i.preventDefault());
    }
    function he() {
      const g = l.getNextMarkKey();
      !g || (l.recoverRight(), a.send(x.Delete, {
        key: g
      }), i.preventDefault());
    }
  }, [o]);
}
const vr = (n) => {
  S("onClick", () => {
    if (n.size === 1) {
      const e = [...n.values()][0].current;
      (e == null ? void 0 : e.textContent) === "" && e.focus();
    }
  }, []);
}, gr = () => {
  const {
    spanRefs: n,
    register: e
  } = fr(), r = dr(), o = lr(n);
  return pr(n, o, r), vr(n), {
    register: e
  };
};
function Er() {
  const {
    bus: n
  } = k(), e = G(null);
  return Z(() => n.set("TextRef", e), []), e;
}
const mr = () => {
  const {
    pieces: n,
    bus: e,
    options: r,
    props: {
      Mark: o,
      ...a
    }
  } = k(), {
    register: i
  } = gr(), l = a.className ? tt + " " + a.className : tt, f = Er(), h = K(() => e.events, [e]);
  return /* @__PURE__ */ D("div", {
    ref: f,
    className: l,
    style: a.style,
    ...h,
    children: [...n].map(([R, E]) => {
      var w, P, F;
      if (!de(E))
        return /* @__PURE__ */ D(ur, {
          ref: i(R),
          id: R,
          value: E
        }, R);
      const b = (F = (P = (w = r[E.childIndex]).initMark) == null ? void 0 : P.call(w, E)) != null ? F : E;
      return /* @__PURE__ */ D(o, {
        tabIndex: -1,
        ...b
      }, R);
    })
  });
}, Rr = (n) => K(() => Qt(n), [n]), yr = (n, e) => {
  const r = K(fe.split(n, e), [n]);
  return K(o, [r.length]);
  function o() {
    return r.reduce((i, l) => i.set(a(l, i), l), /* @__PURE__ */ new Map());
    function a(i, l) {
      let f = de(i) ? i.label + i.value : i, h = 0, R = ce(f, h);
      for (; l.has(R); )
        R = ce(f, h++);
      return R;
    }
  }
};
var le, U, V, Y, ie;
const Pe = class {
  constructor(...e) {
    z(this, Y);
    z(this, le, /* @__PURE__ */ new Map());
    z(this, U, /* @__PURE__ */ new Map());
    z(this, V, {});
    e.forEach((r) => L(this, U).set(r, /* @__PURE__ */ new Set()));
  }
  get events() {
    let e = {};
    for (let r of L(this, U).keys())
      e[r] = (o) => this.send(r, o);
    return e;
  }
  static withExternalEventsFrom(e) {
    const r = new Set(Kt);
    return () => new Pe(...r);
  }
  get(e) {
    if (L(this, V)[e])
      return L(this, V)[e];
    throw new Error(`The ${e} is not exist!`);
  }
  set(e, r) {
    L(this, V)[e] = r;
  }
  send(e, r) {
    ae(this, Y, ie).call(this, e).forEach((o) => o(r));
  }
  listen(e, r) {
    return ae(this, Y, ie).call(this, e).add(r), () => ae(this, Y, ie).call(this, e).delete(r);
  }
};
let be = Pe;
le = new WeakMap(), U = new WeakMap(), V = new WeakMap(), Y = new WeakSet(), ie = function(e) {
  const r = Xt(e) ? L(this, U) : L(this, le);
  return r.has(e) || r.set(e, /* @__PURE__ */ new Set()), r.get(e);
};
function Cr(n) {
  const {
    bus: e,
    pieces: r,
    options: o,
    props: a
  } = n;
  S(x.Change, (i) => {
    const {
      key: l,
      value: f = ""
    } = i;
    r.set(l, f), a.onChange(nt([...r.values()], o));
  }, [r], n), S(x.Delete, (i) => {
    const {
      key: l
    } = i;
    r.delete(l), a.onChange(nt([...r.values()], o));
  }, [r], n), S(x.Select, (i) => {
    const {
      value: l,
      trigger: {
        option: f,
        span: h,
        index: R,
        source: E
      }
    } = i, b = _e(f.markup, l.label, l.value), w = or(h, b, R, E), P = nr(h, r);
    e.send(x.Change, {
      value: w,
      key: P
    });
  }, [r], n);
}
const br = ({
  props: n,
  children: e
}) => {
  const r = Rr(n.children), o = yr(n.value, r), a = xe(be.withExternalEventsFrom(n))[0], i = {
    options: r,
    props: n,
    pieces: o,
    bus: a
  };
  return Cr(i), /* @__PURE__ */ ut(tr, {
    value: i,
    children: [" ", e, " "]
  });
};
class Te {
  static find(e) {
    if (O.isSelectedPosition)
      return new Te().find(e);
  }
  constructor() {
    let e = O.getCurrentPosition();
    this.node = O.getSelectedNode(), this.span = O.getFocusedSpan(), this.dividedText = this.getDividedTextBy(e);
  }
  getDividedTextBy(e) {
    return {
      left: this.span.slice(0, e),
      right: this.span.slice(e)
    };
  }
  find(e) {
    for (let r of e) {
      let o = this.matchInTextVia(r.trigger);
      if (o)
        return {
          value: o.word,
          source: o.annotation,
          index: o.index,
          span: this.span,
          node: this.node,
          option: r
        };
    }
  }
  matchInTextVia(e) {
    const r = this.matchRightPart(), o = this.matchLeftPart(e);
    if (o)
      return {
        word: o.word + r.word,
        annotation: o.annotation + r.word,
        index: o.index
      };
  }
  matchRightPart() {
    var r;
    const {
      right: e
    } = this.dividedText;
    return {
      word: (r = e.match(Gt)) == null ? void 0 : r[0]
    };
  }
  matchLeftPart(e) {
    var f;
    const r = this.makeTriggerRegex(e), {
      left: o
    } = this.dividedText, a = o.match(r);
    if (!a)
      return;
    const [i, l] = a;
    return {
      word: l,
      annotation: i,
      index: (f = a.index) != null ? f : 0
    };
  }
  makeTriggerRegex(e) {
    const r = se(e) + "(\\w*)$";
    return new RegExp(r);
  }
}
const wr = () => {
  const [n, e] = xe(), {
    options: r
  } = k();
  return S(x.ClearTrigger, (o) => e(void 0), []), S(x.CheckTrigger, (o) => e(Te.find(r)), [r]), n;
}, xr = st(({
  trigger: n,
  style: e,
  onSelect: r
}, o) => {
  const [a, i] = xe(NaN), l = K(() => n.option.data.filter((f) => f.toLowerCase().indexOf(n.value.toLowerCase()) > -1), [n.value]);
  return l.length ? /* @__PURE__ */ D("ul", {
    ref: o,
    className: "mk-suggestions",
    style: e,
    children: l.map((f, h) => {
      let R;
      return h === a && (R = "mk-suggestion-active"), /* @__PURE__ */ D("li", {
        className: R,
        onClick: (E) => r({
          label: f,
          value: h.toString()
        }),
        children: f
      }, f);
    })
  }) : null;
});
function _r(n) {
  var l, f, h;
  const {
    bus: e
  } = k(), r = ue(() => e.send(x.ClearTrigger), []), o = ue((R) => e.send(x.Select, {
    value: R,
    trigger: n
  }), [n]), a = O.getAbsolutePosition(), i = {
    trigger: n,
    style: a,
    onSelect: o,
    onClose: r
  };
  return (h = (f = (l = n.option).initOverlay) == null ? void 0 : f.call(l, i)) != null ? h : i;
}
function Sr(n) {
  const {
    bus: e
  } = k();
  Z(() => {
    const r = (o) => {
      let a = o.target;
      a !== n.current && a !== e.get("TextRef").current && (a == null ? void 0 : a.parentElement) !== e.get("TextRef").current && e.send(x.ClearTrigger);
    };
    return document.addEventListener("click", r), () => document.removeEventListener("click", r);
  }, []);
}
function Tr() {
  const {
    bus: n
  } = k();
  Z(() => {
    const e = (r) => {
      r.key === $.ESC && n.send(x.ClearTrigger);
    };
    return window.addEventListener("keydown", e), () => window.removeEventListener("keydown", e);
  }, []);
}
const Pr = (n) => {
  const e = G(null);
  Tr(), Sr(e);
  const r = _r(n), {
    props: {
      Overlay: o = xr
    }
  } = k();
  return /* @__PURE__ */ D(o, {
    ref: e,
    ...r
  });
};
function kr() {
  const {
    bus: n
  } = k(), e = ue(rr(() => n.send(x.CheckTrigger), 20), []);
  S("onFocus", (r) => document.addEventListener("selectionchange", e, {}), []), S("onBlur", (r) => document.removeEventListener("selectionchange", e), []);
}
const Or = () => {
  const n = wr();
  return kr(), n ? /* @__PURE__ */ D(Pr, {
    ...n
  }) : null;
};
function Dr(n) {
  return /* @__PURE__ */ ut(br, {
    props: n,
    children: [/* @__PURE__ */ D(mr, {}), /* @__PURE__ */ D(Or, {})]
  });
}
const Ir = ({
  trigger: n = "@",
  markup: e = "@[__label__](__value__)",
  data: r = [],
  ...o
}) => null;
function Lr(n, e, r) {
  const o = Jt(e) ? {
    Mark: n,
    Overlay: e,
    children: r
  } : {
    Mark: n,
    children: e
  };
  return (a) => {
    const i = it({}, a, o);
    return Dr(i);
  };
}
export {
  Dr as MarkedInput,
  Ir as Option,
  _e as annotate,
  Lr as createMarkedInput,
  jr as denote
};
//# sourceMappingURL=index.js.map
