import { Options, Trigger } from "../types";
export declare class TriggerFinder {
    span: string;
    node: Node;
    dividedText: {
        left: string;
        right: string;
    };
    static find(options: Options): Trigger | undefined;
    constructor();
    getDividedTextBy(position: number): {
        left: string;
        right: string;
    };
    find(options: Options): Trigger | undefined;
    matchInTextVia(trigger: string): {
        word: string;
        annotation: string;
        index: number;
    } | undefined;
    matchRightPart(): {
        word: string | undefined;
    };
    matchLeftPart(trigger: string): {
        word: string;
        annotation: string;
        index: number;
    } | undefined;
    makeTriggerRegex(trigger: string): RegExp;
}
//# sourceMappingURL=TriggerFinder.d.ts.map