import { MutableRefObject, RefObject } from "react";
import { Recovery } from "../components/MarkedText/hooks/useFocus/hooks/useRecoveryAfterRemove";
import { KeyedPieces } from "../types";
export declare class Oracle {
    readonly focusedSpanRef: MutableRefObject<HTMLElement | null>;
    readonly spanRefs: Map<number, RefObject<HTMLSpanElement>>;
    readonly recoveryRef: MutableRefObject<Recovery | null>;
    readonly pieces: KeyedPieces;
    constructor(focusedSpanRef: MutableRefObject<HTMLElement | null>, spanRefs: Map<number, RefObject<HTMLSpanElement>>, recoveryRef: MutableRefObject<Recovery | null>, pieces: KeyedPieces);
    recoverLeft(): void;
    recoverRight(): void;
    getPreviousElement(): HTMLElement | null;
    getNextElement(): HTMLSpanElement | null;
    getPreviousMarkKey(): number | null;
    getNextMarkKey(): number | null;
    getCurrentKey(): number | null;
}
//# sourceMappingURL=Oracle.d.ts.map